
_G[gTable] = {};

local aTmpVal  = gTable;
local aState   = 0;
local aCurCell = 0;
cm.SetupTable(_G[aTmpVal]);


-- Called on Init
_G[gTable].OnInit = function(pObj)
	pObj.mState = 0;
	aState   = pObj.mState;
	aCurCell = pObj.mCurCell;
end


-- Called after data being loaded from disk
_G[gTable].OnLoad = function(pObj)
	aState   = pObj.mState;
	aCurCell = pObj.mCurCell;
end

--Called after level being reloaded
_G[gTable].OnLevelLoad = function(pObj)
	aState   = pObj.mState;
	aCurCell = pObj.mCurCell;
end

-- Called on a update
_G[gTable].OnUpdate = function(pObj)


end


-- Called on a succesful click
_G[gTable].OnClick =  function(pObj, pName, pActorObj, pPolyNum, pX, pY)


	pObj.mDiscovered = true;
	if pName == "" then
      if aState == 0 then
         cm.GetShowInfo(pObj, "InfoStr1", "InfoTime1");
      else
         cm.GetShowInfo(pObj, "InfoStr2", "InfoTime2");
      end
		return true;

	elseif pName == pObj.mCsData:GetString("KeyObject1") then

      if aState == 0 then
      
         pObj:StartFadeRects(PhFadeAnotherTimeLong);
         aState          = aState + 1
         pObj.mState     = aState;
         aCurCell        = aCurCell + 1;
   		pObj.mCurCell   = aCurCell;
   		pObj:SetActive(0, pPolyNum, false);
   		pObj:SetActive(0, pPolyNum + 1, true);

   		pObj:StopParticleEmission(false);
   		_G[pActorObj.mScriptTag].OnUse(pActorObj, pObj);
		   return true;
		else
   		cm.GetShowInfo(pObj, "InfoStr3", "InfoTime3");
   		return false;
   	end

	elseif pName == pObj.mCsData:GetString("KeyObject2")
		 or pName == pObj.mCsData:GetString("KeyObject3")
		 or pName == pObj.mCsData:GetString("KeyObject4")
	then

      if aState > 0 then
         pObj:StartFadeRects(PhFadeAnotherTimeShort);
         aState          = aState + 1
         pObj.mState     = aState;
         aCurCell        = aCurCell + 1;
   		pObj.mCurCell   = aCurCell;

   		pObj:StopParticleEmission(false);
   		_G[pActorObj.mScriptTag].OnUse(pActorObj, pObj);
   		
   		if aState == 4 then
   		   cm.SetGlobalValIndirect(pObj, "SetFlag1", true);
   		   cm.DisableObject(pObj);
			end
		   return true;

		else
   		cm.GetShowInfo(pObj, "InfoStr4", "InfoTime4");
   		return false;
   	end

	else
		cm.ObjDoesNotWork(pObj);
		return false;
	end

	return false;

end



-- Called on draw
_G[gTable].OnDraw =  function(pObj, pG)

	local aRpos = pObj.mSmPos;
	local aImg  = IcImageWrap(pObj.mSmallImage);
	assert(aImg);
	local aRect = aImg:GetCelRect(pObj.mCurCell);
	pG:DrawImage(aImg:GetImage(), aRpos.x, aRpos.y, aRect);

end



